  
import java.awt.*;  
import java.net.*;
import java.io.*;
import java.util.*;
import java.servlet.http.*;

class AdminTabPanel extends java.awt.Panel {

  List dbList;
  public controlbar_admin cbadmin;
  public myTabbedPanel parent;
  String conid="";
  Vector vdbname = new Vector(5);
  Vector vmachine = new Vector(5);
  Vector vurl = new Vector(5);
  Vector vdbtype = new Vector(5);
  String dbname ="";
  
  // gets the value for  key from a hashtable
  private Hashtable get_hashed(String s){
	HttpUtils smutils;
	Hashtable h;
	try {
		smutils = new HttpUtils();
            System.out.println("in get_hashed "+s);
      	h=smutils.parseQueryString(s);
		return h;
	}
	catch(Exception e){
            e.printStackTrace();
		return null;
	}
  }


  public AdminTabPanel(myTabbedPanel mtp){
     this.parent = mtp;
     setLayout(new BorderLayout());
     setFont(new Font("helvetica",Font.BOLD, 12));
     dbList = new List();
     System.out.println("in AdminTabPanel");
     get_remotedblist();
     add("Center",dbList);
     add("North",new Label("Available Databases List",Label.CENTER));
     cbadmin = new controlbar_admin(this);
     add("East",cbadmin);

  }

  // gets the list of databases supported from the remote servlet by making 
  // a connection and retrieving the data

  private void get_remotedblist() {
 
     DataInputStream inStream;
     DataOutputStream outStream;
     Socket sock;
     String currLine="";
     String machine="perseus.npac.syr.edu";
     Hashtable ht;

     // open socket and contact machine 
     try {
   	     sock = new Socket(machine,8080);
	     inStream =  new DataInputStream(sock.getInputStream());
	     outStream = new DataOutputStream(sock.getOutputStream());
	     outStream.writeBytes("GET "+ "/servlet/dbAdmin?GETDBLIST=yes HTTP/1.0 \r\n\r\n");
           System.out.println("making GET to");
	     while ((currLine = inStream.readLine()) != null) {
	  	   if (currLine.length() == 0) break;
		   if (currLine.toLowerCase().startsWith("content-length:")) {
	        	  try {
		 	     int length = Integer.valueOf(currLine.substring(15)).intValue();
			  }catch (Exception ignoreMe) {
			  }
		   }
               System.out.println(currLine);
	     }
          
           while ((currLine = inStream.readLine()) != null){
               System.out.println("inside while in applet");
               ht = get_hashed(currLine);
               vdbname.addElement((String)ht.get("dbname"));                   
               vmachine.addElement((String)ht.get("machine"));                   
               vurl.addElement((String)ht.get("url"));                   
               vdbtype.addElement((String)ht.get("dbtype"));                   
           }
           fill_dbList();
           outStream.flush();
           outStream.close();
           inStream.close();
           sock.close();
     }
     catch(IOException e){
        e.printStackTrace();
     }
  }
 

  private void fill_dbList(){
      // fills the dbList with the dbrecords provided in the dbrecord vector
      // and selects the first one.
      int i;
      for(i=0;i<vdbname.size();i++)
        dbList.addItem((String)vdbname.elementAt(i));
  }

  
 public boolean action(Event e , Object o){
      dbdetail dbdetwin;

      System.out.println("Inside action of myTabbedPanel");

      if(e.target == cbadmin.bConnect){
         String state = (cbadmin.bConnect).getLabel();
         System.out.println(state);

         if(state.equalsIgnoreCase("Connect")){
           System.out.println("Inside action of admin connect button");
           // connect to other servlet and get table details
           if(!((dbList.getSelectedItem()).equals(""))) {
             dbname = dbList.getSelectedItem();
             System.out.println(dbList.getSelectedItem());
             getremoteTableDetails(dbList.getSelectedItem());  
             System.out.println("after getremotetable details");
           }
         }
         else {
           System.out.println("Disconnect button");
           System.out.println("Will disconnect"+dbname);
           // call to the function disconnecting the dbname database
           dbList.enable();
           cbadmin.bConnect.setLabel("Connect");           
           parent.clear_tablelist();
           this.validate();
         }
        return false;
      }
      if(e.target == cbadmin.bDesign){
         System.out.println("Inside action of admin design button");
           // connect to other servlet and get table details
           if(!((dbList.getSelectedItem()).equals(""))) {
             String tmp = dbList.getSelectedItem();
             System.out.println(dbList.getSelectedItem());
             int ind = vdbname.indexOf(tmp);
             System.out.println("index is "+ ind);
             String url="";
             String dbtype="";
             String machine="";

             if(ind != -1){
               url = (String) vurl.elementAt(ind);
               dbtype = (String) vdbtype.elementAt(ind);
               machine = (String) vmachine.elementAt(ind);
               dbdetwin = new dbdetail("Details For "+tmp,tmp,url,machine,dbtype);             
               dbdetwin.show();
               System.out.println("after getremotetable details");
             }
           }
       return false;
      }

      return false;
 }


private void getremoteTableDetails(String s){

    int ind = vdbname.indexOf(s);
    System.out.println("index is "+ ind);
    String url="";
    String dbtype="";
    Vector vtables = new Vector(10);
    Vector vdetails = new Vector(10);
    
    if(ind != -1){
       url = (String) vurl.elementAt(ind);
       dbtype = (String) vdbtype.elementAt(ind);
       System.out.println("url"+ url);
    }

     DataInputStream inStream;
     DataOutputStream outStream;
     Socket sock;
     String currLine="";
     String machine="perseus.npac.syr.edu";
     Hashtable ht;

     // open socket and contact machine 
     try {
   	     sock = new Socket(machine,8080);
	     inStream =  new DataInputStream(sock.getInputStream());
	     outStream = new DataOutputStream(sock.getOutputStream());
	     outStream.writeBytes("GET "+ "/servlet/dbAdmin?GETTABLELIST=yes"+"&dbname="+s+"&url="+url+"&dbtype="+dbtype+" HTTP/1.0 \r\n\r\n");
           System.out.println("making GET to get tables");

	     while ((currLine = inStream.readLine()) != null) {
	  	   if (currLine.length() == 0) break;
		   if (currLine.toLowerCase().startsWith("content-length:")) {
	        	  try {
		 	     int length = Integer.valueOf(currLine.substring(15)).intValue();
			  }catch (Exception ignoreMe) {
			  }
		   }
               System.out.println(currLine);
	     }
           System.out.println("after reading header in applet");
           currLine = inStream.readLine();
           conid = currLine;
           System.out.println("Connection is :"+conid);
           Vector vtmp = new Vector(10);
           while ((currLine = inStream.readLine()) != null){
               if(currLine.startsWith("table")){
                 // is a new table name
                 ht = get_hashed(currLine);
                 vtables.addElement((String)ht.get("table"));                 
                 if (vtmp.size() != 0){
                    vdetails.addElement(vtmp);
                    vtmp.removeAllElements();
                 }
               }
               else {
                 System.out.println(currLine);
                 // is details about the table
                 vtmp.addElement(currLine);
               }
           }
           System.out.println("after adding last-1 tables");
           System.out.println("size of tables"+vtables.size());
           vdetails.addElement(vtmp);
           vtmp.removeAllElements();
           parent.fill_tablelist(vtables,vdetails,dbname,conid);
           System.out.println("after calling fill_tablelist");
           dbList.disable();
           cbadmin.bConnect.setLabel("Detach");           
           this.validate();
           parent.selectTab("Database");
           outStream.flush();
           outStream.close();
           inStream.close();
           sock.close();
     }
     catch(IOException e){
        e.printStackTrace();
     }

}


}


class controlbar_admin extends java.awt.Panel {

  public Button bNew;
  public Button bDelete;
  public Button bDesign;
  public Button bConnect;
  AdminTabPanel a;

  public controlbar_admin(AdminTabPanel p){
     a=p;
     setLayout(new GridLayout(4,1));
     bNew = new Button("New");
     add(bNew);
     bDesign = new Button("Details");
     add(bDesign);
     bDelete = new Button("Delete");
     add(bDelete);
     bConnect = new Button("Connect");
     add(bConnect);
  }

/* public boolean action(Event e , Object o){
      System.out.println("Inside action of controlbar");

      if(e.target == bConnect){
        System.out.println("Inside action of connect button");
        // get the tablenames and details and pass it to the 

      }
      return false;
 }*/

 
}
